'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _stream = require('stream');

var _reusePool = require('reuse-pool');

var _reusePool2 = _interopRequireDefault(_reusePool);

var _webworkifyNode = require('./webworkify-node');

var _webworkifyNode2 = _interopRequireDefault(_webworkifyNode);

var _encodeWorker = require('./encode-worker');

var _encodeWorker2 = _interopRequireDefault(_encodeWorker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var pool = (0, _reusePool2.default)(function () {
  return (0, _webworkifyNode2.default)(_encodeWorker2.default);
});
// Prepare first worker
pool.recycle(pool.get());

var EncoderStream = function (_Transform) {
  _inherits(EncoderStream, _Transform);

  function EncoderStream(codec) {
    _classCallCheck(this, EncoderStream);

    var _this = _possibleConstructorReturn(this, (EncoderStream.__proto__ || Object.getPrototypeOf(EncoderStream)).call(this, { objectMode: true }));

    _this._codec = codec;

    _this._worker = pool.get();
    _this._worker.onmessage = function (msg) {
      if (_this._worker.objectURL) {
        // The object URL can now be revoked as the worker has been loaded
        window.URL.revokeObjectURL(_this._worker.objectURL);
        _this._worker.objectURL = null;
      }
      _this._onMessage(msg.data);
    };
    return _this;
  }

  _createClass(EncoderStream, [{
    key: '_onMessage',
    value: function _onMessage(data) {
      this.push({
        target: data.target,
        codec: this._codec,
        frame: Buffer.from(data.buffer, data.byteOffset, data.byteLength),
        position: data.position
      });
    }
  }, {
    key: '_transform',
    value: function _transform(chunk, encoding, callback) {
      var buffer = chunk.pcm.slice().buffer;
      this._worker.postMessage({
        action: 'encode' + this._codec,
        target: chunk.target,
        buffer: buffer,
        numberOfChannels: chunk.numberOfChannels,
        position: chunk.position
      }, [buffer]);
      callback();
    }
  }, {
    key: '_flush',
    value: function _flush(callback) {
      this._cleanup();
      callback();
    }
  }, {
    key: '_cleanup',
    value: function _cleanup() {
      this._worker.postMessage({ action: 'reset' });
      pool.recycle(this._worker);
    }
  }]);

  return EncoderStream;
}(_stream.Transform);

exports.default = EncoderStream;